/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 48,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 49,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 50,                     /* T_RPT  */
  YYSYMBOL_T_UL = 51,                      /* T_UL  */
  YYSYMBOL_T_NOP = 52,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 53,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 54,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 55,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 56,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 57,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 58,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 59,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 60,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 61,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 62,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 63,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 64,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 65,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 66,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 67,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 68,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 69,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 70,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 71,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 72,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 73,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 74,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 75,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 76,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 77,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 78,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 79,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 80,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 81,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 82,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 83,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 84,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 85,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 86,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 87,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 88,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 89,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 90,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 91,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 92,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 93,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 94,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 95,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 96,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 97,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 98,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 99,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 100,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 101,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 102,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 103,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 104,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 105,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 106,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 107,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 108,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 109,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 110,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 111,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 112,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 113,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 114,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 115,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 116,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 117,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 118,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 119,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 120,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 121,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 122,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 123,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 124,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 125,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 126,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 127,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 128,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 129,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 130,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 131,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 132,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 133,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 134,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 135,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 136,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 137,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 138,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 139,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 140,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 141,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 142,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 143,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 144,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 145,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 146,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 147,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 148,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 149,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 150,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 151,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 152,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 153,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 154,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 155,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 156,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 157,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 158,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 159,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 160,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 161,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 162,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 163,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 164,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 165,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 166,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 167,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 168,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 169,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 170,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 171,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 172,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 173,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 174,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 175,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 176,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 177,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 178,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 179,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 180,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 181,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 182,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 183,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 184,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 185,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 186,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 187,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 188,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 189,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 190,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 191,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 192,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 193,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 194,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 195,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 196,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 197,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 198,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 199,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 200,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 201,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 202,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 203,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 204,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 205,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 206,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 207,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 208,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 209,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 210,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 211,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 212,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 213,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 214,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 215,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 216,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 217,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 218,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 219,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 220,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 221,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 222,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 223,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 224,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 225,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 226,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 227,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 228,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 229,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 230,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 231,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 232,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 233,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 234,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 235,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 236,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 237,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 238,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 239,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 240,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 241,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 242,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 243,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 244,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 245,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 246,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 247,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 248,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 249,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 250,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 251,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 252,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 253,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 254,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 255,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 256,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 257,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 258,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 259,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 260,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 261,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 262,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 263,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 264,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 265,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 266,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 267,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 268,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 269,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 270,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 271,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 272,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 273,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 274,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 275,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 276,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 277,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 278,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 279,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 280,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_BAR = 281,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 282,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 283,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 284,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 285,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 286,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 287,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_CCINV = 288,               /* T_OP_CCINV  */
  YYSYMBOL_T_OP_LOCK = 289,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 290,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 291,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 292,                    /* T_RAW  */
  YYSYMBOL_T_OP_PRINT = 293,               /* T_OP_PRINT  */
  YYSYMBOL_T_TYPE_F16 = 294,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 295,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 296,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 297,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 298,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 299,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 300,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 301,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 302,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 303,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 304,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 305,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 306,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 307,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 308,                     /* T_1D  */
  YYSYMBOL_T_2D = 309,                     /* T_2D  */
  YYSYMBOL_T_3D = 310,                     /* T_3D  */
  YYSYMBOL_T_4D = 311,                     /* T_4D  */
  YYSYMBOL_T_LT = 312,                     /* T_LT  */
  YYSYMBOL_T_LE = 313,                     /* T_LE  */
  YYSYMBOL_T_GT = 314,                     /* T_GT  */
  YYSYMBOL_T_GE = 315,                     /* T_GE  */
  YYSYMBOL_T_EQ = 316,                     /* T_EQ  */
  YYSYMBOL_T_NE = 317,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 318,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 319,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 320,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 321,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 322,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 323,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 324,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 325,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 326,                    /* T_NAN  */
  YYSYMBOL_T_INF = 327,                    /* T_INF  */
  YYSYMBOL_T_A0 = 328,                     /* T_A0  */
  YYSYMBOL_T_A1 = 329,                     /* T_A1  */
  YYSYMBOL_T_P0 = 330,                     /* T_P0  */
  YYSYMBOL_T_W = 331,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 332,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 333,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 334,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 335,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 336,                 /* T_MOD_RT  */
  YYSYMBOL_337_ = 337,                     /* '-'  */
  YYSYMBOL_338_ = 338,                     /* ','  */
  YYSYMBOL_339_ = 339,                     /* '('  */
  YYSYMBOL_340_ = 340,                     /* ')'  */
  YYSYMBOL_341_ = 341,                     /* '='  */
  YYSYMBOL_342_ = 342,                     /* ':'  */
  YYSYMBOL_343_ = 343,                     /* '!'  */
  YYSYMBOL_344_ = 344,                     /* '#'  */
  YYSYMBOL_345_ = 345,                     /* '.'  */
  YYSYMBOL_346_a_ = 346,                   /* 'a'  */
  YYSYMBOL_347_o_ = 347,                   /* 'o'  */
  YYSYMBOL_348_p_ = 348,                   /* 'p'  */
  YYSYMBOL_349_s_ = 349,                   /* 's'  */
  YYSYMBOL_350_ = 350,                     /* '+'  */
  YYSYMBOL_351_ = 351,                     /* '<'  */
  YYSYMBOL_352_g_ = 352,                   /* 'g'  */
  YYSYMBOL_353_ = 353,                     /* '['  */
  YYSYMBOL_354_ = 354,                     /* ']'  */
  YYSYMBOL_355_l_ = 355,                   /* 'l'  */
  YYSYMBOL_356_k_ = 356,                   /* 'k'  */
  YYSYMBOL_357_c_ = 357,                   /* 'c'  */
  YYSYMBOL_358_w_ = 358,                   /* 'w'  */
  YYSYMBOL_359_r_ = 359,                   /* 'r'  */
  YYSYMBOL_360_ = 360,                     /* '>'  */
  YYSYMBOL_361_h_ = 361,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 362,                 /* $accept  */
  YYSYMBOL_shader = 363,                   /* shader  */
  YYSYMBOL_364_1 = 364,                    /* $@1  */
  YYSYMBOL_headers = 365,                  /* headers  */
  YYSYMBOL_header = 366,                   /* header  */
  YYSYMBOL_const_val = 367,                /* const_val  */
  YYSYMBOL_localsize_header = 368,         /* localsize_header  */
  YYSYMBOL_const_header = 369,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 370,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 371,               /* buf_header  */
  YYSYMBOL_372_2 = 372,                    /* $@2  */
  YYSYMBOL_invocationid_header = 373,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 374,              /* wgid_header  */
  YYSYMBOL_numwg_header = 375,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 376,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 377,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 378,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 379,                /* in_header  */
  YYSYMBOL_out_header = 380,               /* out_header  */
  YYSYMBOL_tex_header = 381,               /* tex_header  */
  YYSYMBOL_iflag = 382,                    /* iflag  */
  YYSYMBOL_iflags = 383,                   /* iflags  */
  YYSYMBOL_instrs = 384,                   /* instrs  */
  YYSYMBOL_instr = 385,                    /* instr  */
  YYSYMBOL_label = 386,                    /* label  */
  YYSYMBOL_cat0_src1 = 387,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 388,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 389,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 390,               /* cat0_instr  */
  YYSYMBOL_391_3 = 391,                    /* $@3  */
  YYSYMBOL_392_4 = 392,                    /* $@4  */
  YYSYMBOL_393_5 = 393,                    /* $@5  */
  YYSYMBOL_394_6 = 394,                    /* $@6  */
  YYSYMBOL_395_7 = 395,                    /* $@7  */
  YYSYMBOL_396_8 = 396,                    /* $@8  */
  YYSYMBOL_397_9 = 397,                    /* $@9  */
  YYSYMBOL_398_10 = 398,                   /* $@10  */
  YYSYMBOL_399_11 = 399,                   /* $@11  */
  YYSYMBOL_400_12 = 400,                   /* $@12  */
  YYSYMBOL_401_13 = 401,                   /* $@13  */
  YYSYMBOL_402_14 = 402,                   /* $@14  */
  YYSYMBOL_403_15 = 403,                   /* $@15  */
  YYSYMBOL_404_16 = 404,                   /* $@16  */
  YYSYMBOL_405_17 = 405,                   /* $@17  */
  YYSYMBOL_406_18 = 406,                   /* $@18  */
  YYSYMBOL_cat1_opc = 407,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 408,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 409,              /* cat1_movmsk  */
  YYSYMBOL_410_19 = 410,                   /* $@19  */
  YYSYMBOL_cat1_mova1 = 411,               /* cat1_mova1  */
  YYSYMBOL_412_20 = 412,                   /* $@20  */
  YYSYMBOL_cat1_mova = 413,                /* cat1_mova  */
  YYSYMBOL_414_21 = 414,                   /* $@21  */
  YYSYMBOL_cat1_swz = 415,                 /* cat1_swz  */
  YYSYMBOL_416_22 = 416,                   /* $@22  */
  YYSYMBOL_cat1_gat = 417,                 /* cat1_gat  */
  YYSYMBOL_418_23 = 418,                   /* $@23  */
  YYSYMBOL_cat1_sct = 419,                 /* cat1_sct  */
  YYSYMBOL_420_24 = 420,                   /* $@24  */
  YYSYMBOL_cat1_instr = 421,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 422,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 423,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 424,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 425,                     /* cond  */
  YYSYMBOL_cat2_instr = 426,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 427,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 428,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 429,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 430,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 431,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 432,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 433,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 434,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 435,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 436,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 437,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 438,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 439,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 440,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 441,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 442,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 443,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 444,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 445,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 446,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 447,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 448,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 449,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 450,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 451,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 452, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 453, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 454, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 455,                /* cat6_load  */
  YYSYMBOL_456_25 = 456,                   /* $@25  */
  YYSYMBOL_457_26 = 457,                   /* $@26  */
  YYSYMBOL_458_27 = 458,                   /* $@27  */
  YYSYMBOL_459_28 = 459,                   /* $@28  */
  YYSYMBOL_460_29 = 460,                   /* $@29  */
  YYSYMBOL_461_30 = 461,                   /* $@30  */
  YYSYMBOL_462_31 = 462,                   /* $@31  */
  YYSYMBOL_cat6_store = 463,               /* cat6_store  */
  YYSYMBOL_464_32 = 464,                   /* $@32  */
  YYSYMBOL_465_33 = 465,                   /* $@33  */
  YYSYMBOL_466_34 = 466,                   /* $@34  */
  YYSYMBOL_467_35 = 467,                   /* $@35  */
  YYSYMBOL_468_36 = 468,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 469,              /* cat6_loadib  */
  YYSYMBOL_470_37 = 470,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 471,             /* cat6_storeib  */
  YYSYMBOL_472_38 = 472,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 473,            /* cat6_prefetch  */
  YYSYMBOL_474_39 = 474,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 475,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 476,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 477,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 478,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 479,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 480,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 481,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 482,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 483,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 484,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 485,                 /* cat6_ibo  */
  YYSYMBOL_486_40 = 486,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 487,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 488,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 489,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 490,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 491,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 492, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 493, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 494, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 495,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 496,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 497, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 498,        /* cat6_bindless_ldc  */
  YYSYMBOL_stc_dst = 499,                  /* stc_dst  */
  YYSYMBOL_cat6_stc = 500,                 /* cat6_stc  */
  YYSYMBOL_501_41 = 501,                   /* $@41  */
  YYSYMBOL_502_42 = 502,                   /* $@42  */
  YYSYMBOL_cat6_todo = 503,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 504,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 505,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 506,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 507,             /* cat7_barrier  */
  YYSYMBOL_508_43 = 508,                   /* $@43  */
  YYSYMBOL_509_44 = 509,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 510,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 511,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 512,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 513,               /* cat7_instr  */
  YYSYMBOL_514_45 = 514,                   /* $@45  */
  YYSYMBOL_raw_instr = 515,                /* raw_instr  */
  YYSYMBOL_meta_print = 516,               /* meta_print  */
  YYSYMBOL_src = 517,                      /* src  */
  YYSYMBOL_dst = 518,                      /* dst  */
  YYSYMBOL_const = 519,                    /* const  */
  YYSYMBOL_dst_reg_flag = 520,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 521,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 522,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 523,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 524,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 525,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 526,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 527,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 528,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 529,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 530, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 531,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 532,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 533,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 534,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 535,           /* relative_const  */
  YYSYMBOL_relative = 536,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 537,           /* immediate_cat1  */
  YYSYMBOL_immediate = 538,                /* immediate  */
  YYSYMBOL_flut_immed = 539,               /* flut_immed  */
  YYSYMBOL_integer = 540,                  /* integer  */
  YYSYMBOL_float = 541,                    /* float  */
  YYSYMBOL_type = 542                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 308 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 926 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1517

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  362
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  181
/* YYNRULES -- Number of rules.  */
#define YYNRULES  573
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1190

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   591


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   343,     2,   344,     2,     2,     2,     2,
     339,   340,     2,   350,   338,   337,   345,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   342,     2,
     351,   341,   360,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   353,     2,   354,     2,     2,     2,   346,     2,   357,
       2,     2,     2,   352,   361,     2,     2,   356,   355,     2,
       2,   347,   348,     2,   359,   349,     2,     2,     2,   358,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   712,   712,   712,   714,   715,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   726,   727,   728,   730,   731,
     732,   733,   735,   741,   746,   754,   756,   756,   762,   768,
     775,   782,   791,   793,   795,   798,   800,   802,   809,   810,
     811,   812,   813,   814,   815,   816,   818,   819,   821,   822,
     824,   825,   826,   827,   828,   829,   830,   831,   832,   833,
     834,   836,   838,   839,   841,   842,   844,   845,   847,   848,
     848,   849,   849,   850,   850,   851,   851,   852,   852,   853,
     853,   854,   854,   855,   855,   856,   856,   857,   858,   858,
     859,   860,   861,   862,   863,   864,   865,   865,   866,   867,
     868,   869,   870,   870,   871,   872,   872,   873,   874,   874,
     875,   875,   876,   877,   877,   879,   882,   886,   887,   889,
     889,   905,   905,   912,   912,   919,   919,   921,   921,   923,
     923,   926,   927,   928,   929,   930,   931,   932,   933,   935,
     936,   937,   938,   939,   940,   941,   942,   943,   944,   945,
     946,   947,   948,   950,   951,   952,   953,   954,   955,   957,
     958,   959,   960,   961,   962,   963,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,   976,   977,
     978,   979,   980,   981,   982,   983,   985,   986,   987,   988,
     989,   990,   992,   993,   994,   996,   997,   999,  1000,  1002,
    1003,  1004,  1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1019,  1020,  1021,  1022,  1023,
    1025,  1026,  1028,  1029,  1031,  1032,  1033,  1034,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1047,  1049,
    1050,  1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,
    1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,  1080,
    1081,  1082,  1084,  1085,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1097,  1098,  1099,  1100,  1102,  1103,
    1104,  1105,  1106,  1107,  1108,  1109,  1110,  1111,  1112,  1113,
    1114,  1115,  1116,  1117,  1118,  1119,  1120,  1122,  1123,  1125,
    1126,  1127,  1128,  1130,  1131,  1132,  1133,  1134,  1135,  1137,
    1140,  1145,  1151,  1157,  1160,  1162,  1162,  1163,  1163,  1164,
    1164,  1165,  1165,  1166,  1166,  1167,  1167,  1167,  1171,  1171,
    1172,  1172,  1173,  1173,  1174,  1174,  1175,  1175,  1177,  1177,
    1178,  1178,  1180,  1180,  1182,  1183,  1184,  1185,  1186,  1187,
    1188,  1189,  1190,  1191,  1192,  1194,  1195,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,  1203,  1204,  1206,  1207,  1208,  1209,
    1210,  1211,  1212,  1213,  1214,  1215,  1216,  1218,  1220,  1222,
    1224,  1225,  1226,  1228,  1230,  1231,  1233,  1234,  1235,  1235,
    1238,  1239,  1240,  1242,  1244,  1245,  1247,  1248,  1249,  1251,
    1252,  1254,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1263,
    1264,  1265,  1266,  1267,  1269,  1271,  1272,  1273,  1275,  1279,
    1280,  1282,  1288,  1289,  1290,  1293,  1293,  1294,  1294,  1296,
    1297,  1298,  1300,  1301,  1302,  1303,  1304,  1305,  1306,  1307,
    1308,  1309,  1310,  1311,  1313,  1314,  1315,  1316,  1318,  1319,
    1321,  1321,  1322,  1322,  1324,  1325,  1326,  1328,  1329,  1331,
    1332,  1333,  1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,
    1342,  1349,  1351,  1401,  1402,  1403,  1404,  1406,  1407,  1408,
    1409,  1411,  1413,  1414,  1415,  1416,  1417,  1419,  1420,  1423,
    1424,  1426,  1427,  1428,  1429,  1430,  1432,  1433,  1435,  1436,
    1438,  1439,  1441,  1442,  1444,  1445,  1447,  1448,  1449,  1451,
    1452,  1453,  1455,  1456,  1457,  1459,  1460,  1461,  1463,  1464,
    1466,  1467,  1469,  1470,  1472,  1473,  1479,  1480,  1481,  1482,
    1483,  1484,  1485,  1487,  1488,  1489,  1490,  1491,  1494,  1495,
    1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,  1505,
    1507,  1508,  1509,  1510,  1512,  1513,  1515,  1516,  1517,  1518,
    1519,  1520,  1521,  1522
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP",
  "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC",
  "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL",
  "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT",
  "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS",
  "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG", "T_OP_STG_A",
  "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G",
  "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO",
  "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP",
  "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_OP_CCINV",
  "T_OP_LOCK", "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW", "T_OP_PRINT",
  "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16",
  "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_S8", "T_UNTYPED", "T_TYPED",
  "T_MIXED", "T_UNSIGNED", "T_LOW", "T_HIGH", "T_1D", "T_2D", "T_3D",
  "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN",
  "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM",
  "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX", "T_MOD_MEM", "T_MOD_RT",
  "'-'", "','", "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'",
  "'o'", "'p'", "'s'", "'+'", "'<'", "'g'", "'['", "']'", "'l'", "'k'",
  "'c'", "'w'", "'r'", "'>'", "'h'", "$accept", "shader", "$@1", "headers",
  "header", "const_val", "localsize_header", "const_header",
  "buf_header_addr_reg", "buf_header", "$@2", "invocationid_header",
  "wgid_header", "numwg_header", "branchstack_header", "pvtmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17",
  "$@18", "cat1_opc", "cat1_src", "cat1_movmsk", "$@19", "cat1_mova1",
  "$@20", "cat1_mova", "$@21", "cat1_swz", "$@22", "cat1_gat", "$@23",
  "cat1_sct", "$@24", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_dp_signedness",
  "cat3_dp_pack", "cat3_opc", "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp", "cat5_opc",
  "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type",
  "cat5_a1", "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type",
  "cat6_imm_offset", "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_a6xx_global_address_pt3", "cat6_a6xx_global_address_pt2",
  "cat6_a6xx_global_address", "cat6_load", "$@25", "$@26", "$@27", "$@28",
  "$@29", "$@30", "$@31", "cat6_store", "$@32", "$@33", "$@34", "$@35",
  "$@36", "cat6_loadib", "$@37", "cat6_storeib", "$@38", "cat6_prefetch",
  "$@39", "cat6_atomic_opc", "cat6_a3xx_atomic_opc",
  "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_2src_dst", "cat6_bindless_ibo",
  "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle", "cat6_bindless_ldc",
  "stc_dst", "cat6_stc", "$@41", "$@42", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43", "$@44",
  "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope", "cat7_instr",
  "$@45", "raw_instr", "meta_print", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1005)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1005,    12,  1007, -1005,    63,  -325,    63,  -287,  -269,  -233,
      63,  -202,  -198,  -192,    63, -1005,   881,  1007, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005,    57,  -184,   149, -1005,   158,    27,   171,
   -1005,   174,   175,   204, -1005,  -128, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005,   205,   990,  1226,   782, -1005,
   -1005, -1005, -1005, -1005, -1005,    63,  -122,  -117,  -119,  -115,
    -114,  -107,   -99,   -97,   -92, -1005,   -86, -1005, -1005, -1005,
   -1005, -1005,   -90, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005,   -81, -1005, -1005, -1005, -1005, -1005, -1005, -1005,   -77,
     -60,   -57,   -66,   -46,   -36,   -35,   -34, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,   157, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005,   200,   -19,   200, -1005,
     200,   200,   200,   -18, -1005,   200, -1005,   -14,   -14, -1005,
   -1005, -1005, -1005, -1005, -1005,   -13,   -13,   -13, -1005, -1005,
   -1005, -1005,   -11,   -13,   -13, -1005,   -11, -1005,   -13,   -13,
     -13, -1005,   -10, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005,   -50,    63,   264, -1005, -1005, -1005, -1005, -1005,   330,
     334,   335,   347,  -319,  -319,  -319,    44,  -319,  -319,    11,
      11,    11,  -319,    11,    30,    11,    11,  -319,  -319,    32,
      18,    22,    33,    35,    37,    43,    46,   -11,   -11,   -11,
     -11,   -11,   -11,   -11,   -11,   -13,    28,   -11,   -11,   -13,
     -11,   -11,   -11,    19,    19,    39, -1005,    31, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005,    47, -1005,   291,   177,
      56,    59,    66,  -118,    67,    68,    79,    80,  -227,    82,
      90,   322,   -14,   200,    62,  -182,    88,    88,    88,   749,
      88,    88,    88,   200,    88,    88,    88,    16,    63,    96,
     107,   113,   114,   116, -1005, -1005,   125,   127,   129,   131,
   -1005, -1005,   123, -1005,   141,   151,    25, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005,   200,   200,   200,   200,   138,
     140,   128,   146,    88,   143,   200,   142,    88,   200,   136,
     153,  -230,    19, -1005, -1005,  -130,   180,   185, -1005, -1005,
     109,   109,   771, -1005, -1005, -1005, -1005, -1005, -1005,   200,
     771,   145,   875,   326, -1005, -1005,  -163,   200,   771, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
     186,   749,   200, -1005, -1005,   -73,   -11,   -11,   -11, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,   200,   -11,
     -11, -1005,   -11,   -11,   -11,   182,   187,   195, -1005, -1005,
      63, -1005,   519,   529,    44, -1005,    11,  -279,  -279, -1005,
   -1005,    11,    11,    11, -1005, -1005,    11,   200,   109,   109,
     200,   200,   200,   202,   203,   207,   208,   190,   201,   210,
     211,   -11,   209,   215,   212,   -11,   217,   213,   216, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005,   225,  -240,  -240,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005,   206,   221, -1005,
   -1005, -1005,    99,   222,   223,   219, -1005, -1005, -1005,   260,
      29, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005,    44,   726,   917, -1005, -1005, -1005, -1005,
   -1005,   218,   224,   237,   209, -1005,   241, -1005, -1005, -1005,
     242, -1005, -1005, -1005,   247, -1005,   527,   220,   248, -1005,
   -1005, -1005, -1005,   246,   249,   250,   255,   252,   254,   257,
     258,   262,    44,   231,    42,   273,   272,   278,   283, -1005,
   -1005,   292,   285,   286, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005,   288,   289,   293,   277,   282,   275,   290,   209,   253,
     209,   209,   294,  -239,   280,   209,   296,   281,    54,    54,
     228,    44,    44,   284,   297,   319,   324, -1005,   323,   325,
     287,   327,   332,   331,   345,    70, -1005, -1005, -1005, -1005,
     337,    44, -1005, -1005,   771,   771,   253,   253,   527,   875,
   -1005, -1005,   152,    44,    44,    44,   329,    44,    44,    44,
      44,    44,   338,   342,   351, -1005, -1005,    63,    44,    44,
     687, -1005,    11,    11,   200,   527,   200,   341,   343,   344,
     349,  -240,   354,   148,   348,  -232,  -232,    44,    42, -1005,
     355, -1005,   357,  -232,    44,   358,   362,   359, -1005,   360,
     350, -1005, -1005, -1005, -1005,  -240,  -240, -1005, -1005, -1005,
   -1005, -1005,  -240,  -240,   376,   377, -1005,   379,   382, -1005,
     385,   386,   387,   389, -1005, -1005,   390, -1005,   392,   391,
     393,   394,   378,   200, -1005,   397,   398,   399,   -29,   -29,
      42,   396,   395,   405,   406, -1005, -1005,   408,   412,   413,
     209,   253,   209,   209,   401,   414,   101,    42,   402, -1005,
     403,   200, -1005,   434,   209,   419,   380,    44,    44,   438,
     449,    44,   429,   430,   431,   439, -1005, -1005, -1005,   771,
     145,   875,    50,   253,   480,   152,   448,   465,   466,    42,
     481,   468,   -29,   -29,   -29,   476,   476,   476,   200,   478,
   -1005,    63, -1005, -1005,    44,   527,   527,   200,  -239,   469,
    -239,  -239,   484,   209,   209, -1005,  -200, -1005,   500,   501,
     502,    44,  -239,   506,   495,   497, -1005,   527,    50,   200,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,   511, -1005,
     512,   514,   515,   200,   200,   200,   505,   508,   509,   200,
     527,   200,   533, -1005, -1005, -1005, -1005,   510, -1005,   523,
     526,   530,   531,   517,   534,   520,   536,   209,   535,  -240,
      42,   532, -1005,   209,   209,   539, -1005,   538,   209,    50,
   -1005,   546,   550,   555,   875,   496,   527,   152,   557,   565,
     566, -1005,   552,    42,   568,   569,   584, -1005,   605,   930,
     527,   527,   200,   599,    50,   600,   601,   602,    50,   606,
   -1005,    44,   603,   604,   592,   609,   610,   595,   624,    44,
      44,   321, -1005, -1005, -1005, -1005, -1005,   625,   626, -1005,
     613,   617,   209,    42,   616,    42,    42,    42,   618,   630,
   -1005,   635,   644,    50, -1005,    50,    50,    50, -1005,   632,
    -240,    50,    50,    50,    50,    50,   648,    50, -1005, -1005,
   -1005, -1005, -1005,   496,   527,   640,   641,   657,   642,   659,
   -1005,   662,   663, -1005,    44,   527,   527, -1005, -1005, -1005,
   -1005,   651,   661, -1005, -1005,   654, -1005, -1005,   209, -1005,
   -1005, -1005, -1005,    42,    42,   209,   690,   209,    42,    42,
     691, -1005, -1005,    44,   680,   713,   714,   699,   700, -1005,
     209,   717, -1005, -1005,  1050, -1005,    44,   209,   209,   719,
     720,   721,    42,   722, -1005,   723,   729,   209,   209,   209,
     730,    44,   209,   209, -1005,   731, -1005,   209,   732, -1005,
   -1005,   209, -1005,  1065,   734,   735,   209,    44, -1005, -1005
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    46,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,    45,   481,     0,    46,     0,    46,    49,
      60,    58,    59,     5,    20,     0,     0,    25,     0,     0,
       0,     0,     0,     0,     0,    61,     0,    47,    68,    69,
      71,    73,     0,    77,    79,    81,    83,    85,    87,    88,
      90,    91,    92,    93,    94,    95,    96,    98,    99,   100,
     101,     0,   102,   104,   105,   107,   108,   110,   112,     0,
       0,     0,     0,     0,     0,     0,     0,   159,   160,   161,
     162,   143,   153,   139,   156,   144,   145,   146,   147,   148,
     163,   164,   165,   166,   154,   155,   167,   168,   169,   170,
     140,   171,   172,   149,   173,   157,   158,   174,   175,   176,
     150,   142,   141,   177,   178,   179,   180,   181,   182,   183,
     151,   152,   184,   185,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   222,   223,   220,   221,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   239,   240,   265,   266,   267,   268,   269,
     270,   271,   306,   325,   327,   331,   329,   338,   340,   344,
     342,   348,   439,   440,   352,   333,   346,   441,   393,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     411,   424,   423,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   365,   366,   367,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   383,   384,   385,   386,   394,   395,   350,   428,
     335,   400,   401,   402,   435,   437,   460,   462,   474,   476,
     464,   465,   466,   475,   477,   478,   479,    50,     0,   131,
     132,   133,   134,   135,   136,    51,     0,     0,     0,    52,
       0,     0,     0,     0,    53,     0,    54,   282,   282,    55,
     442,   444,   443,   445,   446,     0,     0,     0,   391,   392,
     390,   447,     0,     0,     0,   448,     0,   449,     0,     0,
       0,   451,     0,   450,   452,   453,    56,   472,   473,    57,
      48,     0,     0,     0,    27,    28,    29,    30,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   458,   458,     0,   487,     0,   492,   493,
     494,   495,   496,   488,   489,   490,     0,   499,   497,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   282,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   482,    63,     0,     0,     0,     0,
     560,   562,     0,    75,     0,     0,     0,    82,    84,    86,
      89,    97,   113,   103,   106,   109,   111,   119,   121,   123,
     115,   116,   125,   127,   129,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   458,   461,   463,     0,     0,     0,   498,   500,
       0,     0,     0,   186,   187,   188,   189,   190,   191,     0,
       0,     0,     0,     0,   195,   196,     0,     0,     0,   272,
     277,   280,   278,   279,   281,   273,   274,   275,   276,   283,
       0,     0,     0,   307,   308,     0,     0,     0,     0,   566,
     567,   568,   569,   570,   571,   572,   573,   313,     0,     0,
       0,   403,     0,     0,     0,     0,     0,     0,   319,    22,
       0,    24,     0,     0,     0,    62,     0,     0,     0,   561,
     563,     0,     0,     0,    67,    66,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   457,
     456,   454,   455,   459,   469,   470,   471,     0,   525,   525,
     483,   491,   501,   502,   503,   504,   505,     0,     0,   484,
     485,   486,     0,     0,     0,     0,   137,   508,   512,   506,
       0,   514,   515,   516,   117,   534,   535,   517,   118,   536,
     138,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,     0,     0,     0,   519,   192,   521,   545,
     543,     0,     0,     0,     0,   522,     0,   523,   524,   510,
       0,   511,   197,   198,     0,   238,     0,     0,   305,   309,
     310,   311,   312,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    70,
      65,     0,     0,     0,    76,    78,    80,   114,   120,   122,
     124,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   525,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   564,     0,     0,
       0,     0,     0,     0,     0,     0,   507,   509,   513,   518,
       0,     0,   547,   520,     0,     0,     0,     0,     0,     0,
     288,   286,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   409,   410,     0,     0,     0,
       0,    64,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   525,     0,     0,     0,   525,   525,     0,     0,   315,
       0,   314,     0,   525,     0,     0,   433,     0,   432,     0,
       0,   527,   526,   531,   530,   525,   525,   541,   542,   565,
     537,   538,   525,   525,     0,     0,   544,     0,     0,   194,
       0,     0,     0,     0,   284,   285,   303,   304,   301,     0,
       0,     0,     0,     0,   398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    72,    74,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   317,
       0,     0,   316,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   539,   540,   546,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   404,   404,   404,     0,     0,
     431,     0,    35,    36,     0,     0,     0,     0,   525,     0,
     525,   525,     0,     0,     0,   324,     0,   318,     0,     0,
       0,     0,   525,     0,     0,     0,   434,     0,     0,     0,
     529,   533,   532,   528,   193,   224,   225,   226,     0,   302,
     299,   300,   295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   407,   408,   406,   429,     0,    23,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   525,
       0,     0,   323,     0,     0,     0,   353,     0,     0,     0,
     336,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   396,     0,     0,     0,     0,     0,   405,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     321,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   227,   296,   297,   287,   298,   293,   294,   289,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     126,     0,     0,     0,   328,     0,     0,     0,   341,     0,
     525,     0,     0,     0,     0,     0,     0,     0,   436,   438,
     480,   467,   468,     0,     0,     0,     0,     0,     0,     0,
     425,     0,     0,   430,     0,     0,     0,   326,   332,   330,
     339,     0,     0,   345,   343,     0,   334,   347,     0,   337,
     290,   291,   292,     0,     0,     0,     0,     0,     0,     0,
       0,   128,   130,     0,     0,     0,     0,     0,     0,   388,
       0,     0,   426,   427,     0,   322,     0,     0,     0,     0,
       0,     0,     0,     0,   320,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   389,     0,   397,     0,     0,   349,
     351,     0,   399,     0,     0,     0,     0,     0,   387,    37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1005, -1005, -1005,  1056, -1005,    -6, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005,  1021, -1005,  1020, -1005,   -84,   482,  -352, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005,  -513, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005,  -333,  -918,  -810,
   -1005, -1004, -1005,   645,   549,   567,   261,  -692,  -757,   -94,
   -1005, -1005,   188, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005,  -774,  -741,   -43,
   -1005, -1005, -1005, -1005, -1005, -1005, -1005,   328, -1005, -1005,
   -1005, -1005, -1005, -1005,  -415, -1005, -1005, -1005, -1005, -1005,
   -1005, -1005, -1005, -1005, -1005,  -292,   646,  -645, -1005,   643,
    -305, -1005,  -469,  -526, -1005, -1005,  -626,  -528,  -498,  -779,
    -606,   540, -1005, -1005,  -536,    23,  -477,   404,  -385,   311,
     528
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,    34,    18,    19,   374,    20,
      67,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      56,    57,    58,    59,    60,   477,   732,   487,   317,   383,
     384,   385,   601,   387,   388,   389,   390,   391,   392,   393,
     395,   396,   397,   398,   606,   318,   656,   319,   607,   320,
     608,   321,   609,   322,   610,   323,   611,   324,   612,   325,
     326,   327,   328,   539,   329,   449,   547,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   452,   453,   866,   867,
     562,  1064,   339,   456,   566,   460,   829,   830,   898,   586,
    1012,   955,   822,   340,   407,   408,   410,   409,   417,   420,
    1058,   341,   411,   412,   414,   413,   418,   342,   415,   343,
     419,   344,   416,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   931,   356,   357,   993,   938,   804,
     358,   359,   360,   361,   362,   587,   363,   837,   364,   421,
     422,   365,   366,   522,   523,   367,   423,   424,   368,  1100,
     637,   369,   425,    61,    62,   657,   437,   658,   438,   439,
     440,   659,   694,   661,   700,   662,   663,   686,   687,   696,
     831,   665,   441,   666,   667,   668,   688,   689,   690,   772,
     577
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   483,   664,   664,    40,   454,   697,   980,    44,   524,
     863,   475,     3,   693,    35,   778,   695,   699,   670,   480,
     481,   442,  1066,   444,   476,   445,   446,   447,   480,   481,
     450,   604,   763,   764,    69,    70,   640,   641,   488,   489,
     778,   491,   692,   493,   494,   480,   481,   480,   481,   640,
     705,   730,    37,   480,   481,   647,   648,   480,   481,   371,
      64,   660,   660,   685,   731,   698,    30,    31,    32,   900,
      38,   685,   660,   480,   481,   767,   905,   544,   545,   685,
     664,   664,   588,   671,   672,   673,   674,   675,   676,   677,
     678,   679,   680,   681,   682,   739,   740,   761,   761,  1131,
    1132,   605,   480,   481,   767,   761,    39,   633,   640,  1067,
     762,   828,   480,   481,   979,   981,   640,   641,   897,   559,
     563,   564,   629,   824,   779,   630,   599,   600,   631,   632,
     642,   643,   644,   645,   646,   647,   648,    41,   939,   660,
     660,    42,   976,   702,   703,   669,   669,    43,   560,   779,
    1010,  1011,   640,   641,    65,   640,   641,    66,   581,   640,
     860,   861,   994,   995,   426,    68,   642,   643,   644,   645,
     646,   647,   648,   642,   643,   644,   645,   646,   778,    71,
     790,    72,    73,   427,   426,   428,   429,   430,   431,   432,
     776,   989,   990,   991,   533,   534,   535,   536,   537,   538,
     613,   614,   615,   616,   634,   635,   636,   426,   783,   728,
     623,    74,    76,   626,    75,  1063,   640,  1068,   372,   899,
     899,   375,   373,   669,   669,   376,   377,   899,   428,   429,
     430,   431,   432,   378,   691,   709,   710,   711,   712,   912,
     913,   379,   704,   380,   729,  1062,   914,   915,   381,   734,
     735,   736,   382,   697,   737,   386,  1003,   708,  1005,  1006,
     640,   641,   862,   695,   394,   824,   868,   771,   399,   400,
    1017,   401,   470,   716,   642,   643,   644,   645,   646,   402,
     823,   642,   643,   644,   645,   646,   858,   859,   468,   888,
     599,   600,   849,  1130,   935,   936,   937,   978,   780,   403,
     478,   479,   738,   484,   485,   741,   742,   743,   490,   404,
     405,   406,   698,   495,   496,   685,   685,   823,   823,   428,
     429,   430,   431,   432,   480,   481,   443,   448,   640,   641,
     753,   451,   455,   640,   459,   467,   471,   588,   585,   806,
     472,   473,   642,   643,   644,   645,   646,   642,   643,   644,
     645,   646,   647,   482,   474,   486,   498,   649,   650,   651,
     499,   492,   482,   497,   521,   500,   469,   501,   777,   502,
     649,   650,   651,   838,   838,   503,   841,   842,   504,   482,
     514,   482,   526,   836,   525,   697,   653,   482,   654,   683,
     854,   482,   975,   777,   530,   695,   857,   531,   527,   982,
      33,   561,   777,  1049,   532,   540,   541,   770,   588,   588,
     588,   684,   588,   588,   588,   588,   588,   542,   543,  1000,
    1001,   974,   823,   882,   883,   768,   769,   546,   548,   649,
     650,   651,   805,   565,   590,  1101,   770,   649,   650,   651,
     954,  1021,   588,   842,   698,   977,   482,   591,   652,   588,
     685,   660,   592,   593,   823,   595,   821,   594,   825,   826,
     885,   886,   589,   833,  1035,   596,   653,   597,   654,   598,
     655,   864,   865,   649,   650,   651,   649,   650,   651,   602,
     649,   650,   651,   619,  1122,   433,   434,   435,   697,   603,
     617,  1022,   618,   627,   620,   806,   622,   624,   695,  1065,
    1065,  1069,   653,   640,   654,   433,   434,   435,   638,   887,
     628,   889,   842,   639,  1080,  1081,   436,   642,   643,   644,
     645,   646,   965,   966,   706,   726,   969,   722,   433,   434,
     435,   777,   723,   724,   640,   727,   902,   649,   650,   651,
     744,   745,  1057,   748,   806,   746,   747,   698,   642,   643,
     644,   645,   646,   754,   749,   757,   784,   765,   775,   999,
     791,   840,   785,   750,   751,   755,   758,  1084,   930,   759,
     760,  1088,   766,   773,   774,   786,   588,  1065,  1065,   787,
     788,   649,   650,   651,   725,   789,   792,   803,   805,  1141,
    1142,   793,   823,   796,   794,   795,   960,   797,   948,   798,
     950,   951,   799,   800,   956,   957,  1117,   801,  1118,  1119,
    1120,   807,   962,   808,  1123,  1124,  1125,  1126,  1127,   809,
    1129,   810,   811,   812,   813,   806,   814,   815,   802,   817,
     819,   816,   549,   996,   818,   832,   835,   805,   820,   827,
     550,   834,  1002,   551,   843,   552,   553,   845,   806,   649,
     650,   651,   846,   554,   649,   650,   651,   844,   482,   852,
     652,  1008,  1009,   847,  1023,   848,  1090,   850,   555,   556,
     557,   558,   851,   853,   588,   588,   669,   856,  1028,  1029,
    1030,   872,   655,   878,  1034,   654,  1036,   879,   806,   880,
     806,   806,   806,   884,   890,   911,   891,   892,   896,   869,
     870,   871,   893,   873,   874,   875,   876,   877,   895,   903,
     904,   907,   908,   909,   910,  1047,   916,   917,   805,   918,
     919,  1052,  1053,   920,   921,   922,  1056,   923,   924,  1140,
     925,   929,   964,   901,   941,   942,   926,  1082,   927,   928,
     906,   805,   932,   933,   934,   943,   945,   944,   806,   806,
     946,   947,   953,   806,   806,   952,   958,   959,  1155,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,  1164,   961,   963,   480,   481,   967,   806,   640,   641,
    1107,   805,    -3,   805,   805,   805,  1178,   968,    45,   970,
     971,   972,   642,   643,   644,   645,   646,   647,   648,   973,
     865,   881,  1189,   983,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   865,   984,   985,   987,
     988,   992,  1007,  1004,   649,   650,   651,    46,    47,    48,
      49,    50,    51,    52,    53,   997,  1146,   940,  1013,  1014,
    1015,   805,   805,  1149,  1018,  1151,   805,   805,  1019,  1024,
    1025,  1020,  1026,  1027,  1037,   649,   650,   651,  1161,  1031,
    1032,  1039,  1033,  1038,  1040,  1165,  1166,  1016,  1041,  1042,
     805,  1043,  1044,  1048,  1045,  1174,  1175,  1176,   480,   481,
    1179,  1180,   640,  1051,  1059,  1182,   986,    45,  1060,  1184,
    1046,  1054,  1055,  1061,  1188,  1070,   642,   643,   644,   645,
     646,   647,   648,  1071,  1072,  1073,  1075,  1076,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     480,   481,  1077,   463,   640,   641,    46,    47,    48,    49,
      50,    51,    52,    53,  1078,   998,  1079,  1083,  1085,  1086,
    1087,  1091,  1092,   647,   648,  1093,  1089,  1094,  1095,  1096,
     671,   672,   673,   674,   675,   676,   677,   678,   679,   680,
     681,   682,  1097,  1103,  1104,  1098,  1099,  1050,  1105,  1106,
    1109,  1114,  1113,  1115,   505,   506,   507,   508,   509,   510,
     511,   512,  1116,  1121,   515,   516,  1128,   518,   519,   520,
    1074,   457,   458,  1133,  1134,  1135,  1136,  1137,   461,   462,
    1138,  1139,  1143,   464,   465,   466,   567,   568,  1145,   578,
     579,   580,  1144,   582,   583,   584,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,  1150,  1154,
    1108,  1156,  1110,  1111,  1112,    46,    47,    48,    49,    50,
      51,    52,    53,   569,   570,   571,   572,   573,   574,   575,
     576,  1157,  1158,  1159,  1160,  1162,  1163,  1167,  1168,  1169,
     513,  1172,   621,  1171,   517,   781,   625,  1173,  1177,  1181,
    1183,  1185,  1186,    63,    54,    55,  1187,    77,   370,   949,
     733,   528,   894,   701,  1102,   529,   855,   839,   782,   707,
    1147,  1148,     0,     0,     0,  1152,  1153,     0,     0,   649,
     650,   651,     0,     0,     0,     0,     0,     0,   482,     0,
     683,     0,     0,     0,     0,     0,     0,     0,     0,  1170,
       0,     0,     0,     0,     0,     0,     0,     0,   653,     0,
     654,     0,   684,   713,   714,   715,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   717,   718,     0,   719,
     720,   721,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    54,    55,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   752,     0,
       0,     0,   756,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   649,   650,   651,     0,     0,     0,     0,
       0,     0,   482,     0,   683,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   653,     0,   654,     0,   684,     0,     0,     0,
       0,     0,     0,     0,     0,   649,   650,   651,     0,     0,
       0,     0,     0,     0,   482,     0,   683,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   653,     0,   654,     0,   684,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316
};

static const yytype_int16 yycheck[] =
{
       6,   386,   530,   531,    10,   338,   542,   925,    14,   424,
     789,   330,     0,   541,   339,   660,   542,   543,   531,     3,
       4,   326,  1026,   328,   343,   330,   331,   332,     3,     4,
     335,     6,   638,   639,     7,     8,     7,     8,   390,   391,
     685,   393,   540,   395,   396,     3,     4,     3,     4,     7,
     548,   330,   339,     3,     4,    26,    27,     3,     4,    65,
       3,   530,   531,   532,   343,   542,     3,     4,     5,   826,
     339,   540,   541,     3,     4,     5,   833,   304,   305,   548,
     608,   609,   467,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,   608,   609,   337,   337,  1103,
    1104,   486,     3,     4,     5,   337,   339,   522,     7,  1027,
     350,   350,     3,     4,   924,   925,     7,     8,   350,   452,
     302,   303,   352,   749,   660,   355,     3,     4,   358,   359,
      21,    22,    23,    24,    25,    26,    27,   339,   879,   608,
     609,   339,   921,   306,   307,   530,   531,   339,   453,   685,
     350,   351,     7,     8,   338,     7,     8,     8,   463,     7,
     786,   787,   936,   937,     7,     7,    21,    22,    23,    24,
      25,    26,    27,    21,    22,    23,    24,    25,   823,     8,
     706,     7,     7,    26,     7,    28,    29,    30,    31,    32,
     659,   932,   933,   934,   312,   313,   314,   315,   316,   317,
     505,   506,   507,   508,   334,   335,   336,     7,   685,   594,
     515,     7,     7,   518,   342,  1025,     7,  1027,   340,   825,
     826,   340,   339,   608,   609,   340,   340,   833,    28,    29,
      30,    31,    32,   340,   539,   308,   309,   310,   311,   845,
     846,   340,   547,   340,   596,  1024,   852,   853,   340,   601,
     602,   603,   338,   789,   606,   345,   948,   562,   950,   951,
       7,     8,   788,   789,   345,   891,   792,   652,   345,   329,
     962,   328,     8,   578,    21,    22,    23,    24,    25,   345,
     749,    21,    22,    23,    24,    25,   784,   785,   338,   815,
       3,     4,     5,  1103,   323,   324,   325,   923,   683,   345,
     384,   385,   607,   387,   388,   610,   611,   612,   392,   345,
     345,   345,   789,   397,   398,   784,   785,   786,   787,    28,
      29,    30,    31,    32,     3,     4,   345,   345,     7,     8,
     622,   345,   345,     7,   345,   345,     6,   722,   322,   724,
       6,     6,    21,    22,    23,    24,    25,    21,    22,    23,
      24,    25,    26,   337,     7,   344,   338,   328,   329,   330,
     338,   331,   337,   331,   345,   332,   372,   332,   660,   332,
     328,   329,   330,   758,   759,   332,   761,   762,   332,   337,
     352,   337,   351,   329,   345,   921,   357,   337,   359,   339,
     775,   337,   920,   685,   338,   921,   781,   338,   351,   925,
     337,   339,   694,  1009,   338,   338,   338,   337,   793,   794,
     795,   361,   797,   798,   799,   800,   801,   338,   338,   945,
     946,   919,   891,   808,   809,   326,   327,   345,   338,   328,
     329,   330,   724,   345,   338,  1061,   337,   328,   329,   330,
     339,   967,   827,   828,   921,   922,   337,   340,   339,   834,
     919,   920,   339,   339,   923,   330,   748,   341,   750,   751,
     812,   813,   468,   755,   990,   338,   357,   338,   359,   338,
     361,   319,   320,   328,   329,   330,   328,   329,   330,   338,
     328,   329,   330,   355,  1090,   328,   329,   330,  1024,   338,
     352,   968,   352,   357,   348,   880,   353,   355,  1024,  1025,
    1026,  1027,   357,     7,   359,   328,   329,   330,   328,   814,
     357,   816,   897,   328,  1040,  1041,   359,    21,    22,    23,
      24,    25,   907,   908,   338,     6,   911,   345,   328,   329,
     330,   823,   345,   338,     7,     6,   828,   328,   329,   330,
     338,   338,  1019,   353,   929,   338,   338,  1024,    21,    22,
      23,    24,    25,   338,   353,   338,   338,   351,   339,   944,
     340,   333,   338,   353,   353,   353,   353,  1044,   873,   353,
     345,  1048,   351,   351,   351,   338,   961,  1103,  1104,   338,
     338,   328,   329,   330,   590,   338,   338,   356,   880,  1115,
    1116,   345,  1061,   338,   345,   345,   901,   345,   890,   345,
     892,   893,   345,   345,   896,   897,  1083,   345,  1085,  1086,
    1087,   338,   904,   341,  1091,  1092,  1093,  1094,  1095,   341,
    1097,   338,   330,   338,   338,  1010,   338,   338,   722,   352,
     355,   338,   310,   938,   352,   355,   355,   929,   348,   345,
     318,   345,   947,   321,   360,   323,   324,   328,  1033,   328,
     329,   330,   328,   331,   328,   329,   330,   360,   337,   328,
     339,   953,   954,   340,   969,   340,  1051,   340,   346,   347,
     348,   349,   340,   328,  1059,  1060,  1061,   340,   983,   984,
     985,   352,   361,   345,   989,   359,   991,   345,  1073,   338,
    1075,  1076,  1077,     6,   353,   345,   353,   353,   350,   793,
     794,   795,   353,   797,   798,   799,   800,   801,   354,   354,
     353,   353,   350,   354,   354,  1007,   340,   340,  1010,   340,
     338,  1013,  1014,   338,   338,   338,  1018,   338,   338,  1114,
     338,   353,   352,   827,   338,   340,   345,  1042,   345,   345,
     834,  1033,   345,   345,   345,   340,   338,   341,  1133,  1134,
     338,   338,   338,  1138,  1139,   354,   354,   354,  1143,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,  1156,   338,   354,     3,     4,   338,  1162,     7,     8,
    1072,  1073,     0,  1075,  1076,  1077,  1171,   338,     6,   360,
     360,   360,    21,    22,    23,    24,    25,    26,    27,   360,
     320,   807,  1187,   355,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,   320,   352,   352,   338,
     352,   345,   338,   354,   328,   329,   330,    45,    46,    47,
      48,    49,    50,    51,    52,   357,  1128,   880,   338,   338,
     338,  1133,  1134,  1135,   338,  1137,  1138,  1139,   353,   338,
     338,   354,   338,   338,   321,   328,   329,   330,  1150,   354,
     352,   338,   353,   353,   338,  1157,  1158,   961,   338,   338,
    1162,   354,   338,   338,   354,  1167,  1168,  1169,     3,     4,
    1172,  1173,     7,   351,   338,  1177,   929,     6,   338,  1181,
     354,   352,   354,   338,  1186,   338,    21,    22,    23,    24,
      25,    26,    27,   338,   338,   353,   338,   338,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
       3,     4,   338,   356,     7,     8,    45,    46,    47,    48,
      49,    50,    51,    52,   329,   941,     6,   338,   338,   338,
     338,   338,   338,    26,    27,   353,   340,   338,   338,   354,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,   338,   338,   338,  1059,  1060,  1010,   355,   352,
     354,   341,   354,   338,   407,   408,   409,   410,   411,   412,
     413,   414,   338,   351,   417,   418,   338,   420,   421,   422,
    1033,   346,   347,   353,   353,   338,   354,   338,   353,   354,
     338,   338,   351,   358,   359,   360,   457,   458,   354,   460,
     461,   462,   351,   464,   465,   466,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,   338,   338,
    1073,   351,  1075,  1076,  1077,    45,    46,    47,    48,    49,
      50,    51,    52,   294,   295,   296,   297,   298,   299,   300,
     301,   338,   338,   354,   354,   338,     6,   338,   338,   338,
     415,   338,   513,   341,   419,   339,   517,   338,   338,   338,
     338,     6,   338,    17,   292,   293,   341,    56,    58,   891,
     598,   438,   821,   543,  1061,   439,   775,   759,   684,   561,
    1133,  1134,    -1,    -1,    -1,  1138,  1139,    -1,    -1,   328,
     329,   330,    -1,    -1,    -1,    -1,    -1,    -1,   337,    -1,
     339,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   357,    -1,
     359,    -1,   361,   566,   567,   568,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   579,   580,    -1,   582,
     583,   584,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   292,   293,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   621,    -1,
      -1,    -1,   625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   328,   329,   330,    -1,    -1,    -1,    -1,
      -1,    -1,   337,    -1,   339,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   357,    -1,   359,    -1,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   328,   329,   330,    -1,    -1,
      -1,    -1,    -1,    -1,   337,    -1,   339,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   357,    -1,   359,    -1,   361,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   363,   364,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   365,   366,   368,   369,
     371,   373,   374,   375,   376,   377,   378,   379,   380,   381,
       3,     4,     5,   337,   367,   339,   367,   339,   339,   339,
     367,   339,   339,   339,   367,     6,    45,    46,    47,    48,
      49,    50,    51,    52,   292,   293,   382,   383,   384,   385,
     386,   515,   516,   365,     3,   338,     8,   372,     7,     7,
       8,     8,     7,     7,     7,   342,     7,   383,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   390,   407,   409,
     411,   413,   415,   417,   419,   421,   422,   423,   424,   426,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   444,
     455,   463,   469,   471,   473,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   487,   488,   492,   493,
     494,   495,   496,   498,   500,   503,   504,   507,   510,   513,
     385,   367,   340,   339,   370,   340,   340,   340,   340,   340,
     340,   340,   338,   391,   392,   393,   345,   395,   396,   397,
     398,   399,   400,   401,   345,   402,   403,   404,   405,   345,
     329,   328,   345,   345,   345,   345,   345,   456,   457,   459,
     458,   464,   465,   467,   466,   470,   474,   460,   468,   472,
     461,   501,   502,   508,   509,   514,     7,    26,    28,    29,
      30,    31,    32,   328,   329,   330,   359,   518,   520,   521,
     522,   534,   522,   345,   522,   522,   522,   522,   345,   427,
     522,   345,   438,   439,   439,   345,   445,   445,   445,   345,
     447,   445,   445,   447,   445,   445,   445,   345,   338,   367,
       8,     6,     6,     6,     7,   330,   343,   387,   387,   387,
       3,     4,   337,   540,   387,   387,   344,   389,   389,   389,
     387,   389,   331,   389,   389,   387,   387,   331,   338,   338,
     332,   332,   332,   332,   332,   447,   447,   447,   447,   447,
     447,   447,   447,   445,   352,   447,   447,   445,   447,   447,
     447,   345,   505,   506,   506,   345,   351,   351,   521,   518,
     338,   338,   338,   312,   313,   314,   315,   316,   317,   425,
     338,   338,   338,   338,   304,   305,   345,   428,   338,   310,
     318,   321,   323,   324,   331,   346,   347,   348,   349,   439,
     522,   339,   442,   302,   303,   345,   446,   446,   446,   294,
     295,   296,   297,   298,   299,   300,   301,   542,   446,   446,
     446,   522,   446,   446,   446,   322,   451,   497,   540,   367,
     338,   340,   339,   339,   341,   330,   338,   338,   338,     3,
       4,   394,   338,   338,     6,   540,   406,   410,   412,   414,
     416,   418,   420,   522,   522,   522,   522,   352,   352,   355,
     348,   446,   353,   522,   355,   446,   522,   357,   357,   352,
     355,   358,   359,   506,   334,   335,   336,   512,   328,   328,
       7,     8,    21,    22,    23,    24,    25,    26,    27,   328,
     329,   330,   339,   357,   359,   361,   408,   517,   519,   523,
     524,   525,   527,   528,   529,   533,   535,   536,   537,   540,
     408,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   339,   361,   524,   529,   530,   538,   539,
     540,   522,   530,   529,   524,   525,   531,   536,   538,   525,
     526,   533,   306,   307,   522,   530,   338,   542,   522,   308,
     309,   310,   311,   447,   447,   447,   522,   447,   447,   447,
     447,   447,   345,   345,   338,   367,     6,     6,   540,   389,
     330,   343,   388,   388,   389,   389,   389,   389,   522,   408,
     408,   522,   522,   522,   338,   338,   338,   338,   353,   353,
     353,   353,   447,   517,   338,   353,   447,   338,   353,   353,
     345,   337,   350,   532,   532,   351,   351,     5,   326,   327,
     337,   540,   541,   351,   351,   339,   524,   517,   519,   536,
     540,   339,   539,   538,   338,   338,   338,   338,   338,   338,
     525,   340,   338,   345,   345,   345,   338,   345,   345,   345,
     345,   345,   451,   356,   491,   517,   540,   338,   341,   341,
     338,   330,   338,   338,   338,   338,   338,   352,   352,   355,
     348,   517,   454,   524,   528,   517,   517,   345,   350,   448,
     449,   532,   355,   517,   345,   355,   329,   499,   540,   499,
     333,   540,   540,   360,   360,   328,   328,   340,   340,     5,
     340,   340,   328,   328,   540,   541,   340,   540,   530,   530,
     528,   528,   525,   531,   319,   320,   440,   441,   525,   451,
     451,   451,   352,   451,   451,   451,   451,   451,   345,   345,
     338,   367,   540,   540,     6,   389,   389,   522,   525,   522,
     353,   353,   353,   353,   448,   354,   350,   350,   450,   532,
     450,   451,   517,   354,   353,   450,   451,   353,   350,   354,
     354,   345,   532,   532,   532,   532,   340,   340,   340,   338,
     338,   338,   338,   338,   338,   338,   345,   345,   345,   353,
     522,   486,   345,   345,   345,   323,   324,   325,   490,   490,
     491,   338,   340,   340,   341,   338,   338,   338,   517,   454,
     517,   517,   354,   338,   339,   453,   517,   517,   354,   354,
     522,   338,   517,   354,   352,   540,   540,   338,   338,   540,
     360,   360,   360,   360,   530,   529,   531,   538,   528,   441,
     440,   441,   525,   355,   352,   352,   491,   338,   352,   490,
     490,   490,   345,   489,   489,   489,   522,   357,   367,   540,
     525,   525,   522,   449,   354,   449,   449,   338,   517,   517,
     350,   351,   452,   338,   338,   338,   451,   449,   338,   353,
     354,   525,   538,   522,   338,   338,   338,   338,   522,   522,
     522,   354,   352,   353,   522,   525,   522,   321,   353,   338,
     338,   338,   338,   354,   338,   354,   354,   517,   338,   532,
     491,   351,   517,   517,   352,   354,   517,   538,   462,   338,
     338,   338,   531,   441,   443,   525,   443,   440,   441,   525,
     338,   338,   338,   353,   491,   338,   338,   338,   329,     6,
     525,   525,   522,   338,   538,   338,   338,   338,   538,   340,
     540,   338,   338,   353,   338,   338,   354,   338,   451,   451,
     511,   528,   537,   338,   338,   355,   352,   517,   491,   354,
     491,   491,   491,   354,   341,   338,   338,   538,   538,   538,
     538,   351,   532,   538,   538,   538,   538,   538,   338,   538,
     441,   443,   443,   353,   353,   338,   354,   338,   338,   338,
     540,   525,   525,   351,   351,   354,   517,   491,   491,   517,
     338,   517,   491,   491,   338,   540,   351,   338,   338,   354,
     354,   517,   338,     6,   540,   517,   517,   338,   338,   338,
     491,   341,   338,   338,   517,   517,   517,   338,   540,   517,
     517,   338,   517,   338,   517,     6,   338,   341,   517,   540
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   362,   364,   363,   365,   365,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   367,   367,
     367,   367,   368,   369,   370,   370,   372,   371,   373,   374,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   382,
     382,   382,   382,   382,   382,   382,   383,   383,   384,   384,
     385,   385,   385,   385,   385,   385,   385,   385,   385,   385,
     385,   386,   387,   387,   388,   388,   389,   389,   390,   391,
     390,   392,   390,   393,   390,   394,   390,   395,   390,   396,
     390,   397,   390,   398,   390,   399,   390,   390,   400,   390,
     390,   390,   390,   390,   390,   390,   401,   390,   390,   390,
     390,   390,   402,   390,   390,   403,   390,   390,   404,   390,
     405,   390,   390,   406,   390,   407,   407,   408,   408,   410,
     409,   412,   411,   414,   413,   416,   415,   418,   417,   420,
     419,   421,   421,   421,   421,   421,   421,   421,   421,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   423,   423,   423,   423,   423,   423,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   425,   425,   425,   425,
     425,   425,   426,   426,   426,   427,   427,   428,   428,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   430,   430,   430,   430,   430,
     431,   431,   432,   432,   433,   433,   433,   433,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   435,   436,
     436,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   438,   438,   438,   438,   438,
     438,   438,   439,   439,   440,   441,   442,   443,   444,   444,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   444,   444,   444,   444,   444,   444,   445,   445,   446,
     446,   446,   446,   447,   448,   449,   449,   450,   450,   451,
     452,   452,   453,   453,   454,   456,   455,   457,   455,   458,
     455,   459,   455,   460,   455,   461,   462,   455,   464,   463,
     465,   463,   466,   463,   467,   463,   468,   463,   470,   469,
     472,   471,   474,   473,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   478,   479,   480,
     481,   481,   481,   482,   483,   484,   485,   485,   486,   485,
     487,   487,   487,   488,   489,   489,   490,   490,   490,   491,
     491,   492,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   494,   495,   495,   495,   496,   497,
     497,   498,   499,   499,   499,   501,   500,   502,   500,   503,
     503,   503,   504,   504,   504,   504,   504,   504,   504,   504,
     504,   504,   504,   504,   505,   505,   505,   505,   506,   506,
     508,   507,   509,   507,   510,   510,   510,   511,   511,   512,
     512,   512,   513,   513,   513,   513,   513,   513,   513,   514,
     513,   515,   516,   517,   517,   517,   517,   518,   518,   518,
     518,   519,   520,   520,   520,   520,   520,   521,   521,   522,
     522,   523,   523,   523,   523,   523,   524,   524,   525,   525,
     526,   526,   527,   527,   528,   528,   529,   529,   529,   530,
     530,   530,   531,   531,   531,   532,   532,   532,   533,   533,
     534,   534,   535,   535,   536,   536,   537,   537,   537,   537,
     537,   537,   537,   538,   538,   538,   538,   538,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     540,   540,   540,   540,   541,   541,   542,   542,   542,   542,
     542,   542,   542,   542
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     2,     1,     2,     1,     2,     2,     1,     0,
       5,     0,     7,     0,     7,     0,     5,     0,     5,     0,
       5,     0,     3,     0,     3,     0,     3,     1,     0,     3,
       1,     1,     1,     1,     1,     1,     0,     3,     1,     1,
       1,     1,     0,     3,     1,     0,     3,     1,     0,     3,
       0,     3,     1,     0,     5,     3,     3,     1,     1,     0,
       5,     0,     5,     0,     5,     0,    11,     0,    13,     0,
      13,     1,     1,     1,     1,     1,     1,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     8,     6,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     8,     8,     8,    10,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     1,     1,     3,     1,     5,    10,
      12,    12,    12,    10,    10,     8,    10,    10,    10,     8,
       8,     6,     8,     6,     6,     4,     1,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     1,     2,     1,
       7,     2,     7,     2,     3,     0,    12,     0,    11,     0,
      12,     0,    12,     0,    12,     0,     0,    12,     0,    12,
       0,    11,     0,    12,     0,    12,     0,    12,     0,    17,
       0,    17,     0,     9,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,    20,    13,    16,
       1,     1,     1,     1,     1,     1,     9,    16,     0,    17,
       1,     1,     1,     3,     0,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,    11,    13,    13,     1,     6,
       9,     7,     1,     1,     3,     0,    11,     0,    11,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     0,     2,
       0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
      11,     1,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     0,     2,     2,     5,     5,
       5,     5,     5,     5,     1,     1,     1,     3,     3,     4,
       4,     3,     3,     1,     3,     1,     4,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 712 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3147 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 730 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3153 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 731 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3159 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 732 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3165 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 733 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3171 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 735 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 741 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3189 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 746 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* $@2: %empty  */
#line 756 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3212 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 762 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3222 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 768 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 775 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3245 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 782 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 791 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 793 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 795 "../src/freedreno/ir3/ir3_parser.y"
                                        { info->early_preamble = 1; }
#line 3276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 798 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_SY  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SS  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_JP  */
#line 811 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_EQ_FLAG  */
#line 812 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_SAT  */
#line 813 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_RPT  */
#line 814 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_UL  */
#line 815 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* iflag: T_NOP  */
#line 816 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* instr: iflags cat5_instr  */
#line 829 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* label: T_IDENTIFIER ':'  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_src1: '!' T_P0  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_src1: T_P0  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* cat0_src2: '!' T_P0  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* cat0_src2: T_P0  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_immed: '#' integer  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* cat0_immed: '#' T_IDENTIFIER  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* cat0_instr: T_OP_NOP  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* $@3: %empty  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* $@4: %empty  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@5: %empty  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@6: %empty  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@7: %empty  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@8: %empty  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@9: %empty  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@10: %empty  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@11: %empty  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* cat0_instr: T_OP_RET  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* $@12: %empty  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_END  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_EMIT  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_CUT  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_CHMASK  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_CHSH  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* cat0_instr: T_OP_FLOW_REV  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* $@13: %empty  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_STKS  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_STKR  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* cat0_instr: T_OP_XSET  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 101: /* cat0_instr: T_OP_XCLR  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* $@14: %empty  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_DBG  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* $@15: %empty  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* cat0_instr: T_OP_SHPE  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3552 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* $@16: %empty  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* $@17: %empty  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3564 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* cat0_instr: T_OP_PREDE  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3570 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* $@18: %empty  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3576 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 116: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@19: %empty  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3602 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 120: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@19 dst_reg  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3618 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@20: %empty  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3629 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* $@21: %empty  */
#line 912 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* $@22: %empty  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* $@23: %empty  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 129: /* $@24: %empty  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 943 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_NOT_B  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_1src: T_OP_SETRM  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_ADD_F  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MIN_F  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_MAX_F  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_MUL_F  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_ADD_U  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_ADD_S  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_SUB_U  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3820 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_SUB_S  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3826 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MIN_U  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3832 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MIN_S  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3838 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_MAX_U  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3844 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_MAX_S  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3850 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_AND_B  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3856 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_OR_B  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3862 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_XOR_B  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3868 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3874 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3880 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_MULL_U  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3886 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_SHL_B  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3892 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_SHR_B  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3898 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3904 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_BARY_F  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3910 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3916 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3922 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3928 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_SHB  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3934 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat2_opc_2src: T_OP_MSAD  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3940 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cond: T_LT  */
#line 985 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3946 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cond: T_LE  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3952 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cond: T_GT  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3958 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cond: T_GE  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3964 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cond: T_EQ  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3970 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cond: T_NE  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3976 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_dp_signedness: '.' T_MIXED  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3982 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 3988 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_dp_pack: '.' T_LOW  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 3994 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_dp_pack: '.' T_HIGH  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 4000 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_MAD_U16  */
#line 1002 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 4006 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_MADSH_U16  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 4012 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_MAD_S16  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4018 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_MADSH_M16  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4024 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_opc: T_OP_MAD_U24  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4030 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_S24  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4036 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_MAD_F16  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4042 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_MAD_F32  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4048 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_SEL_B16  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4054 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_SEL_B32  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4060 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_SEL_S16  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4066 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_SEL_S32  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4072 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_SEL_F16  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4078 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SEL_F32  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4084 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_opc: T_OP_SAD_S16  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4090 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_opc: T_OP_SAD_S32  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4096 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4102 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4108 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4114 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4120 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4126 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_wmm: T_OP_WMM  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4132 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4138 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_dp: T_OP_DP2ACC  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4144 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat3_dp: T_OP_DP4ACC  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4150 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat4_opc: T_OP_RCP  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4156 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat4_opc: T_OP_RSQ  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4162 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat4_opc: T_OP_LOG2  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4168 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat4_opc: T_OP_EXP2  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4174 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat4_opc: T_OP_SIN  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4180 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_COS  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4186 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_SQRT  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4192 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_HRSQ  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4198 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat4_opc: T_OP_HLOG2  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4204 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat4_opc: T_OP_HEXP2  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4210 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4216 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4222 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_ISAM  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 4228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_ISAML  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_ISAMM  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4240 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_SAM  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4246 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc: T_OP_SAMB  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4252 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc: T_OP_SAML  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_SAMGQ  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4264 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_GETLOD  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4270 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_CONV  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4276 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_CONVM  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4282 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_GETSIZE  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_GETBUF  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_GETPOS  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_GETINFO  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_DSX  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_DSY  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GATHER4R  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GATHER4G  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_GATHER4B  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_GATHER4A  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAMGP0  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGP1  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_SAMGP2  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_SAMGP3  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_RGETPOS  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_RGETINFO  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_BRCST_A  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1079 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_flag: '.' T_3D  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_flag: '.' 'a'  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_flag: '.' 'o'  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_flag: '.' 'p'  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_flag: '.' 's'  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_S2EN  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' T_UNIFORM  */
#line 1090 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1091 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_flag: '.' T_BASE  */
#line 1092 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat5_flag: '.' T_W  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_samp: T_SAMP  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_tex: T_TEX  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_type: '(' type ')'  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat5_a1: src_reg  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* cat5_instr: T_OP_TCINV  */
#line 1120 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_typed: '.' T_UNTYPED  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_typed: '.' T_TYPED  */
#line 1123 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_dim: '.' T_1D  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_dim: '.' T_2D  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* cat6_dim: '.' T_3D  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* cat6_dim: '.' T_4D  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_type: '.' type  */
#line 1130 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_imm_offset: offset  */
#line 1131 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_dst_offset: offset  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4552 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat6_immed: integer  */
#line 1137 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1140 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_a6xx_global_address_pt3: '+' cat6_reg_or_immed  */
#line 1145 "../src/freedreno/ir3/ir3_parser.y"
                                         {
                        // Dummy src to smooth the difference between a6xx and a7xx
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                   }
#line 4577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4587 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* $@25: %empty  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4593 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* $@26: %empty  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4599 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* $@27: %empty  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4605 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* $@28: %empty  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4611 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* $@29: %empty  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4617 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* $@30: %empty  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4623 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* $@31: %empty  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@32: %empty  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* $@33: %empty  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 342: /* $@34: %empty  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* $@35: %empty  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 346: /* $@36: %empty  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 348: /* $@37: %empty  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* $@38: %empty  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* $@39: %empty  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1182 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1185 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1188 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1190 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1192 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1194 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1195 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1196 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1204 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1207 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1212 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1213 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1215 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 393: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4883 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4889 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4895 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* $@40: %empty  */
#line 1235 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4901 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* cat6_id_opc: T_OP_GETSPID  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4907 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* cat6_id_opc: T_OP_GETWID  */
#line 1239 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4913 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 4919 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_bindless_base: '.' T_BASE  */
#line 1245 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4925 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4931 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_reg_or_immed: integer  */
#line 1252 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4937 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4943 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1256 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4949 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1257 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4955 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4961 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1259 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4967 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1260 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4973 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4979 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1262 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 4985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 4991 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 4997 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 5003 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 5009 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 5015 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1269 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 5021 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1272 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5027 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1273 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 5033 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5039 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1279 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5045 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1280 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5051 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* stc_dst: integer  */
#line 1288 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* stc_dst: T_A1  */
#line 1289 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* stc_dst: T_A1 '+' integer  */
#line 1290 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* $@41: %empty  */
#line 1293 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* $@42: %empty  */
#line 1294 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* cat6_todo: T_OP_G2L  */
#line 1296 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* cat6_todo: T_OP_L2G  */
#line 1297 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* cat6_todo: T_OP_RESFMT  */
#line 1298 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 454: /* cat7_scope: '.' 'w'  */
#line 1313 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* cat7_scope: '.' 'r'  */
#line 1314 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 456: /* cat7_scope: '.' 'l'  */
#line 1315 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 457: /* cat7_scope: '.' 'g'  */
#line 1316 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 460: /* $@43: %empty  */
#line 1321 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* $@44: %empty  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 464: /* cat7_data_cache: T_OP_DCCLN  */
#line 1324 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* cat7_data_cache: T_OP_DCINV  */
#line 1325 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* cat7_data_cache: T_OP_DCFLU  */
#line 1326 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* cat7_alias_scope: T_MOD_TEX  */
#line 1331 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* cat7_alias_scope: T_MOD_MEM  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_alias_scope: T_MOD_RT  */
#line 1333 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* cat7_instr: T_OP_SLEEP  */
#line 1337 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* cat7_instr: T_OP_CCINV  */
#line 1338 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_CCINV); }
#line 5193 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* cat7_instr: T_OP_ICINV  */
#line 1339 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5199 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* cat7_instr: T_OP_LOCK  */
#line 1340 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5205 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* cat7_instr: T_OP_UNLOCK  */
#line 1341 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5211 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* $@45: %empty  */
#line 1342 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1345 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* raw_instr: T_RAW  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5234 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* meta_print: T_OP_PRINT T_REGISTER ',' T_REGISTER  */
#line 1351 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
	/* low */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst((yyvsp[-2].num), IR3_REG_R);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova & 0xffffffff;

	/* high */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst((yyvsp[-2].num) + 2, IR3_REG_R);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova >> 32;

	/* offset */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst((yyvsp[-2].num) + 4, IR3_REG_R);
	new_src(0, IR3_REG_IMMED)->uim_val = 4;

	new_instr(OPC_NOP);
	instr->repeat = 5;

	/* Increment and get current offset into print buffer */
	new_instr(OPC_ATOMIC_G_ADD);
	instr->cat6.d = 1;
	instr->cat6.typed = 0;
	instr->cat6.type = TYPE_U32;
	instr->cat6.iim_val = 1;

	new_dst((yyvsp[-2].num), IR3_REG_R);
	new_src((yyvsp[-2].num), IR3_REG_R);
	new_src((yyvsp[-2].num) + 4, IR3_REG_R);

	/* Store the value */
	new_instr(OPC_STG);
	dummy_dst();
	instr->cat6.type = TYPE_U32;
	instr->flags = IR3_INSTR_SY;
	new_src((yyvsp[-2].num), IR3_REG_R);
	new_src(0, IR3_REG_IMMED)->iim_val = 0;
	new_src((yyvsp[0].num), IR3_REG_R);
	new_src(0, IR3_REG_IMMED)->iim_val = 1;

	new_instr(OPC_NOP);
	instr->flags = IR3_INSTR_SY;
}
#line 5288 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* src: T_REGISTER  */
#line 1401 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5294 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* src: T_A0  */
#line 1402 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5300 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* src: T_A1  */
#line 1403 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5306 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* src: T_P0  */
#line 1404 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 5312 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* dst: T_REGISTER  */
#line 1406 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5318 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 488: /* dst: T_A0  */
#line 1407 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5324 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 489: /* dst: T_A1  */
#line 1408 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5330 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 490: /* dst: T_P0  */
#line 1409 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 5336 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* const: T_CONSTANT  */
#line 1411 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5342 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 492: /* dst_reg_flag: T_EVEN  */
#line 1413 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5348 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* dst_reg_flag: T_POS_INFINITY  */
#line 1414 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5354 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1415 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5360 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* dst_reg_flag: T_EI  */
#line 1416 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5366 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* dst_reg_flag: T_WRMASK  */
#line 1417 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5372 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 499: /* dst_reg: dst  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5378 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 500: /* dst_reg: dst_reg_flags dst  */
#line 1424 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5384 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 501: /* src_reg_flag: T_ABSNEG  */
#line 1426 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5390 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 502: /* src_reg_flag: T_NEG  */
#line 1427 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5396 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 503: /* src_reg_flag: T_ABS  */
#line 1428 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5402 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* src_reg_flag: T_R  */
#line 1429 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5408 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* src_reg_flag: T_LAST  */
#line 1430 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5414 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* offset: %empty  */
#line 1459 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5420 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 526: /* offset: '+' integer  */
#line 1460 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 527: /* offset: '-' integer  */
#line 1461 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5432 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 528: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1463 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5438 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 529: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1464 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5444 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 530: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1466 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5450 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 531: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1467 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5456 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 532: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1469 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5462 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 533: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1470 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5468 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* immediate_cat1: integer  */
#line 1479 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5474 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* immediate_cat1: '(' integer ')'  */
#line 1480 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5480 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 538: /* immediate_cat1: '(' float ')'  */
#line 1481 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5486 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1482 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5492 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* immediate_cat1: 'h' '(' float ')'  */
#line 1483 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5498 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* immediate_cat1: '(' T_NAN ')'  */
#line 1484 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 542: /* immediate_cat1: '(' T_INF ')'  */
#line 1485 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 543: /* immediate: integer  */
#line 1487 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 544: /* immediate: '(' integer ')'  */
#line 1488 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 545: /* immediate: flut_immed  */
#line 1489 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 546: /* immediate: 'h' '(' integer ')'  */
#line 1490 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 547: /* immediate: 'h' flut_immed  */
#line 1491 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* integer: T_INT  */
#line 1507 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5546 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 561: /* integer: '-' T_INT  */
#line 1508 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5552 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 562: /* integer: T_HEX  */
#line 1509 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 563: /* integer: '-' T_HEX  */
#line 1510 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5564 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* float: T_FLOAT  */
#line 1512 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5570 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* float: '-' T_FLOAT  */
#line 1513 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5576 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* type: T_TYPE_F16  */
#line 1515 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 5582 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* type: T_TYPE_F32  */
#line 1516 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 5588 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 568: /* type: T_TYPE_U16  */
#line 1517 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 5594 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 569: /* type: T_TYPE_U32  */
#line 1518 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 5600 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 570: /* type: T_TYPE_S16  */
#line 1519 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 5606 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 571: /* type: T_TYPE_S32  */
#line 1520 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 5612 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 572: /* type: T_TYPE_U8  */
#line 1521 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 5618 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 573: /* type: T_TYPE_S8  */
#line 1522 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 5624 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5628 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

